Subject: Re: [yang-doctors] YANG module statement

From: Benoit Claise <[email-masked]>
Date: Tue, 13 Sep 2016 17:20:25 +0200

Dear all,

Sorry for dropping the ball just before my vacation  (+ some PC issues 
lately, now recovered).
It's about time to restart the discussion on this one.

Regards, Benoit
> On Tue, Jul 26, 2016 at 06:29:19PM +0200, Benoit Claise wrote:
>> On 7/26/2016 6:16 PM, Juergen Schoenwaelder wrote:
>>> On Tue, Jul 26, 2016 at 05:53:57PM +0200, Benoit Claise wrote:
>>>> Dear YANG doctors,
>>>>
>>>> The RTG and OPS ADs came up with this guidance:
>>>>
>>>>      YANG modules SHOULD NOT be structured to include nodes/leaves to
>>>>      indicate applied configuration
>>>>      If the YANG module is sufficently advanced, it MAY be structured to
>>>>      include nodes/leaves to indicate applied configuration.
>>>>      If you do so, you SHOULD place nodes/leaves that are specific to the
>>>>      applied configuration in a model augmentation
>>>>
>>>>      We would like to thank the RT design team for the excellent suggestion.
>>>>
>>>> Note: Lou being THE person making this statement happen, and checking with
>>>> TEAS, PCE, MPLS (and CCAMP)
>>>>
>>>> We would like to validate this sentence with you: "you SHOULD place
>>>> nodes/leaves that are specific to the applied configuration in an model
>>>> augmentation". Lou can explain the details, if necessary.
>>>>
>>>> So any strong objection to this guidance? The end goal is to have an email
>>>> sent on behalf of the RTG and OPS ADs, posted soon, ideally tomorrow
>>>> evening.
>>> Yes, I have a strong objection since terms are undefined (i.e.,
>>> 'applied configuration', 'sufficiently advanced'). A policy using
>>> undefined terms is for me useless. So who is going to decide whether a
>>> leaf is 'applied configuration' or not?
>> basically, we don't want to duplicate all the leafs, like openconfig did.
> We have duplicated several leafs in ietf-interfaces. Please clarify
> whether your policy targets duplication (i) inside a single tree or
> (ii) at the leaves of a tree or (iii) at two different roots (i.e.,
> the /foo and /foo-state model) or a certain combination of the three
> or all of them. I just can't tell from the way the policy is worded.
>
>>> Who is going to decided
>>> whether a model is 'sufficiently advanced'?
>> The ADs. Example: IDR BGP has got multiple implementations
>> already. What do we do with this?  The SHOULDs are there to leave
>> the door open for very particular cases.
> You mean draft-ietf-idr-bgp-model-02.txt? This document needs updates
> anyway to turn it from openconfig models into IETF models and that
> likely will require implementations to change; perhaps the early
> implementors are better off publishing the openconfig models they
> implement as Informational or Experimental documents.
>
> But back to the topic, perhaps clarify in the policy that the ADs
> (that is the respective area ADs and the OPS AD together) decide what
> is 'sufficently advanced'.
>
> /js
>